<?php
// add the admin options page
add_action('admin_menu', 'rlb_plugin_admin_add_page');
function rlb_plugin_admin_add_page() {
	add_options_page('Related Links Blender Page - BETA', 'Related Links Blender Menu', 'manage_options', 'rlb_plugin_options_page', 'rlb_plugin_options_page');
}

// display the admin options page
function rlb_plugin_options_page() {
?>
        <div>
        <h2>Related Links Blender Settings</h2>
        <form action="options.php" method="post">
        <? settings_fields('rlb_plugin_options'); ?>
        <? do_settings_sections('rlb_plugin_options_page'); ?>
         
        <input name="Submit" type="submit" value="<? esc_attr_e('Save Changes'); ?>" />
        </form></div>
         
        <?
}
function rlb_plugin_section_text() {
echo '<p>These are global options for the plugin and how it will function.  Choosing links to append to Pages and Posts is done on their individual editing pages.</p>';
echo '<p>This plugin is BETA and not recommended for production websites</p>';
//$options = get_option('rlb_plugin_options'); echo '<p>'.var_dump($options).'</p>';

} 


// add the admin settings and such
add_action('admin_init', 'rlb_plugin_admin_init');

function rlb_plugin_admin_init(){
	register_setting( 'rlb_plugin_options', 'rlb_plugin_options', 'rlb_plugin_options_validate' );

	add_settings_section('rlb_settings', 'Main Settings', 'rlb_plugin_section_text', 'rlb_plugin_options_page');
	
	//add_settings_field('rlb_controls_page', 'Add links to Pages', 'rlb_plugin_setting_checkbox', 'rlb_plugin_options_page', 'rlb_settings','rlb_controls_page');
	add_settings_field('rlb_controls_post', 'Add links to Posts', 'rlb_plugin_setting_checkbox', 'rlb_plugin_options_page', 'rlb_settings','rlb_controls_post');
	
	add_settings_field('rlb_wrapper_prefix', 'HTML opening tags before the links', 'rlb_plugin_setting_string', 'rlb_plugin_options_page', 'rlb_settings','rlb_wrapper_prefix');

	add_settings_field('rlb_link_wrapper_prefix', 'HTML tags before a link', 'rlb_plugin_setting_string', 'rlb_plugin_options_page', 'rlb_settings','rlb_link_wrapper_prefix');
	add_settings_field('rlb_link_wrapper_suffix', 'HTML closing tags after a link', 'rlb_plugin_setting_string', 'rlb_plugin_options_page', 'rlb_settings','rlb_link_wrapper_suffix');

	add_settings_field('rlb_wrapper_suffix', 'HTML closing tags after the links', 'rlb_plugin_setting_string', 'rlb_plugin_options_page', 'rlb_settings','rlb_wrapper_suffix');


	add_settings_field('rlb_styles', 'Styles for your links', 'rlb_plugin_setting_textarea', 'rlb_plugin_options_page', 'rlb_settings','rlb_styles');

	//add_settings_field('rlb_test_option', 'Test Option (ignore me)', 'rlb_plugin_setting_string', 'rlb_plugin_options_page', 'rlb_settings','rlb_test_option');

}



function rlb_plugin_setting_string($who_am_i) {
	$options = get_option('rlb_plugin_options');
	echo "<input id='$who_am_i' name='rlb_plugin_options[$who_am_i]' size='100' type='text' value='{$options[$who_am_i]}' />";
}

function rlb_plugin_setting_checkbox($who_am_i) {
	$options = get_option('rlb_plugin_options');
	echo "<input id='$who_am_i' name='rlb_plugin_options[$who_am_i]' type='checkbox' value='checked' ".checked( $options[$who_am_i] ,true,false)." />";
}

function rlb_plugin_setting_textarea($who_am_i) {
	$options = get_option('rlb_plugin_options');
	echo "<textarea rows='10' cols='100' id='$who_am_i' name='rlb_plugin_options[$who_am_i]'>{$options[$who_am_i]}</textarea>";
}

// validate our options
function rlb_plugin_options_validate($input) {
	
	$options = get_option('rlb_plugin_options');

	$input['rlb_controls_page'] = ($input['rlb_controls_page']=='checked') ? true : false;
	$input['rlb_controls_post'] = ($input['rlb_controls_post']=='checked') ? true : false;;
	
	foreach ($input as $key => $value) {
		if (array_key_exists($key,$options)) {
			if (is_string($input[$key]))  $options[$key]=esc_textarea(trim($input[$key]));
			if (is_bool($input[$key]))  $options[$key]=$input[$key];
		}
	}
	return $options;

}



// validate our options
function rlb_plugin_options_activation_initialize() {


	$default_options = array(
	'rlb_a_test_option'=>'I am just a test field with no function',
	
	'rlb_controls_page'=>false,
	'rlb_controls_post'=>false,

	'rlb_wrapper_prefix'=>"<div class=\"rlb_related_links\"><h2>Related Posts:</h2>",
	'rlb_wrapper_suffix'=>'</div>',

	'rlb_link_wrapper_prefix'=>"<p class=\"rlb_related_link\">",
	'rlb_link_wrapper_suffix'=>'</p>',

	'rlb_styles'=>"
		.rlb_related_links  {margin: 0 0 25px 15px;	}
		.rlb_related_links  h2 {margin-left:0px;	}
		.rlb_related_links p {
				height:52px; width:450px;
						padding-left:0px;
				margin:10px 0 0 0;
				overflow:hidden;
		}
		.rlb_related_link img {
				height:50px; width:50px;
				float:left;
						margin-right:5px;
				border:1px solid #555;
		}"
	);


	$options = get_option('rlb_plugin_options');
	
	if (!$options) { //options will be false on a fresh install
		$options= $default_options;
		foreach ($options as $key => $value) {
				if (is_string($options[$key]))  $options[$key]= htmlentities(trim($options[$key]));
		}
	} else {
		foreach ($default_options as $key => $value) {
			if (!array_key_exists($key,$options)) {
				if (is_string($default_options[$key]))  $options[$key]= htmlentities(trim($default_options[$key]));
				if (is_bool($default_options[$key]))  $options[$key]=$default_options[$key];
			} 
		}

	}

		
	update_option( "rlb_plugin_options", $options );
}

	
/*
function rlb_plugin_options_defaults($requested) {
	
	
	if (strlen($requested)>0) {
		return $options[$requested];
	} else {
		return $options;
	}
	
}
*/


/***************************************************************************
 Define the custom box 
****************************************************************************/


// WP 3.0+
add_action( 'add_meta_boxes', 'rlb_post_options_metabox' );

// backwards compatible
add_action( 'admin_init', 'rlb_post_options_metabox', 1 );

/* Do something with the data entered */
add_action( 'save_post', 'rlb_save_post_options' );

/**
 *  Adds a box to the main column on the Post edit screen
 * 
 */
function rlb_post_options_metabox() {
    add_meta_box( 'post_options', __( 'Relevant Links Blender BETA' ), 'rlb_post_options_code', 'post', 'normal', 'high' );
}

/**
 *  Prints the box content
 */
function rlb_post_options_code( $post ) { 
    wp_nonce_field( plugin_basename( __FILE__ ), $post->post_type . '_noncename' );
    $rlb_meta = get_post_meta( $post->ID, 'rlb_meta', true) ? get_post_meta( $post->ID, 'rlb_meta', true) : 1; ?>
    <h2>Include local links by post ID</h2><h2 style="width:200px;position:absolute;top:0px;right:10px;text-align:right;">This post ID: <?=$post->ID?></h2>
        <input id="rlb_meta[related_links_by_id]" type="text" width="10" name="rlb_meta[related_links_by_id]" value="<?=$rlb_meta[related_links_by_id]?>" /> <label >comma seperated list of posts to link</label><br />
    <hr /><?php
}

/** 
 * When the post is saved, saves our custom data 
 */
function rlb_save_post_options( $post_id ) {
  // verify if this is an auto save routine. 
  // If it is our form has not been submitted, so we dont want to do anything
  if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
      return;

  // verify this came from the our screen and with proper authorization,
  // because save_post can be triggered at other times
  if ( !wp_verify_nonce( @$_POST[$_POST['post_type'] . '_noncename'], plugin_basename( __FILE__ ) ) )
      return;

  // Check permissions
  if ( !current_user_can( 'edit_post', $post_id ) )
     return;

  // OK, we're authenticated: we need to find and save the data
  if( 'post' == $_POST['post_type'] ) {
      if ( !current_user_can( 'edit_post', $post_id ) ) {
          return;
      } else {
          update_post_meta( $post_id, 'rlb_meta', $_POST['rlb_meta'] );
      }
  } 

}





?>